/*      FONCTIONS        FONCTIONS        FONCTIONS        FONCTIONS        FONCTIONS        FONCTIONS        FONCTIONS        FONCTIONS        FONCTIONS        FONCTIONS        FONCTIONS        FONCTIONS        FONCTIONS        FONCTIONS        */
/**
 * @description Say if the Graphml get from the request contains element.
 * @type {boolean}
 */
var isGraphmlOk = true;
/**
 * Définis le Qtip sur les boutons
 */
function initQtipButton () {
    $('#parameter').qtip({
        position: {
            my: 'top center',
            at: 'bottom center'
        },

        show: {
            event: 'click'
        },
        hide: {
            event: 'click'
        },

        style: {
            classes: 'qtip-bootstrap personalQtipStyle',
            tip: {
                width: 16,
                height: 8
            },
            left: -10
        },

        content: $('#parameters')
    });
}
/**
 * @description Ajout dynamique de chaque classe de filtre en fonction des éléments passé en paramètre.
 */
function createFiltersClasses() {
    filterClass.sort();

    var innerHtml = '<ul id="classes_liste">';
    for (var index in filterClass)
        /*Ajout d'une puce sous forme de liste ordonnée avec un checkbox*/
        innerHtml += '<li class="' + (index % 2 === 0 ? "pair" : "impair") + '"><label for="input'+filterClass[index]+'"><span  class="' + filterClass[index].toLowerCase() + '"></span>' + filterClass[index] + '</label><input id="input'+filterClass[index]+'" class="nodeclass" type="checkbox" value="' + filterClass[index] + '" checked="checked"></li>';
    innerHtml += '</ul>';

    $("#classes_div").append(innerHtml);
}
/**
 * Donne les valeurs sélectionner pour les différentes checkbox de filtrage.
 * @returns {Array<String>}
 */
function getLabelFiltre() {
    var valArray = [];

    $.each($("#filters_classes .nodeclass"), function (index, valeur) {
        if (!valeur.checked) valArray.push(valeur.value);
    });

    return valArray;
}
/**
 * @description Popup show if there is to much nodes.
 * @returns {boolean}
 */
function popup_confirm(nbr_node) {
    return confirm("Selected graph contains " + nbr_node + " nodes.\nPress OK to continue or press Cancel to modify settings.");
}
/**
 * Create the help dialog.
 */
function createHelpDialog () {
    $("#help_dialog").dialog(
        {
            autoOpen  : false,
            width     : 600,
            height    : 600,
            position  : {at : "center center"},
            open        : function(event, ui){
                $(this).parent().find('.ui-dialog-title').html("<div class='iconedialog help_dialog'></div><p style='width:100%; text-align:center'>Help</p>");
            }
        }
    ).dialogExtend(
        {
            "closable" : true,
            "minimizable" : true,
            "minimizeLocation" : dialogMinimizeLocation,
            "icons" : {
                "close" : "ui-icon-circle-close",
                "minimize" : "ui-icon-circle-minus"
            }
        }
    );
}
/**
 * @description Affiche les informations du node.
 * @param {Object} node Un node provenant directement de cytoscape.
 */
function showNodeInfo (node) {
    var data = node.data();
    var innerHtml = "<button id='print_dialog' class='droit no-print'>Print</button><h1 class='hidden'>" + data["description"] + " " + data["class"] + "</h1><p>" ;
    var width, height;
    
    if ($("#infos").dialog("instance") !== undefined) {
        width = $("#infos").dialog("option", "width");
        height = $("#infos").dialog("option", "height");
        $("#infos").dialog("close");
    } else {
        width = 250;
        height = 300;
    }
    
    var dialog = $("#infos").dialog(
        {
            autoOpen    : false,
            width       : width,
            height      : height,
            position    : {at : "left+2% top+2%"},
            title       : data["description"] + " " + data["class"],
            open        : function(event, ui){
                $(this).parent().find('.ui-dialog-title').prepend("<div id='node_class_dialog' class='iconedialog " + data["class"] + "'></div>");
            },
            close       : function (event, ui) {
                $("#dialog").dialog("destroy");
            }
        }
    ).dialogExtend({
        "closable" : true,
        "minimizable" : true,
        "minimizeLocation" : dialogMinimizeLocation,
        "icons" : {
            "close" : "ui-icon-circle-close",
            "minimize" : "ui-icon-circle-minus"
            }
        }
    );

    innerHtml += node.data(node_a.data.hiddenProperties)[node_p.me].show();

    innerHtml += "</p>";

    $('#infos').html(innerHtml);
    
    $("#print_dialog").click(function () {
        $("#infos").print({
            globalStyles: false,
            stylesheet: racineUrl + "resource/css/dialog_print.css",
            iframe: true,
            manuallyCopyFormValues: false
        });
    });
    
    dialog.dialog("open");
}
/**
 *
 * @param {object} edge
 */
function showEdgeInfo (edge) {
    var data = edge.data();
    var innerHtml = "<button id='print_dialog' class='droit no-print'>Print</button><h1 style='text-align: justify;'>" + data[edge_a.data.source] + "<br />to<br />" + data[edge_a.data.target] + "</h1><p>" ;
    var width, height;

    if ($("#infos").dialog("instance") !== undefined) {
        width = $("#infos").dialog("option", "width");
        height = $("#infos").dialog("option", "height");
        $("#infos").dialog("close");
    } else {
        width = 250;
        height = 300;
    }

    var dialog = $("#infos").dialog(
        {
            autoOpen    : false,
            width       : width,
            height      : height,
            position    : {at : "left+2% top+2%"},
            title       : "EDGE " + data["id"],
            open        : function(event, ui){
                $(this).parent().find("#node_class_dialog").remove();
            },
            close       : function (event, ui) {
                $("#dialog").dialog("destroy");
            }
        }
    ).dialogExtend({
            "closable" : true,
            "minimizable" : true,
            "minimizeLocation" : dialogMinimizeLocation,
            "icons" : {
                "close" : "ui-icon-circle-close",
                "minimize" : "ui-icon-circle-minus"
            }
        }
    );

    innerHtml += edge.data(edge_a.data.hiddenProperties)[edge_p.me].show();

    innerHtml += "</p>";

    $('#infos').html(innerHtml);

    $("#print_dialog").click(function () {
        $("#infos").print({
            globalStyles: false,
            stylesheet: racineUrl + "resource/css/dialog_print.css",
            iframe: true,
            manuallyCopyFormValues: false
        });
    });

    dialog.dialog("open");
}
/**
 * Affiche ou Cache les possibles groupage d'éléments en fonction du layout sélectionner.
 * @param {String} selection Le layout selectionner.
 */
function afficheCacheLayoutGroup (selection) {
    if ($.inArray((JSON.parse(selection)).nom, compatibleGroupLayout) !== -1) {         // Si le nom du layout se trouve dans la liste des layouts compatible.
        $(document.querySelectorAll("input[name=\"group\"]")).prop("disabled", false);  // On active les radios bouton pour le changement de groupe.
        $("#layout-group").fadeIn(150);                                                 // Et on affiche la zone concerné.
        $("#collapse_group").fadeIn(150);
    } else {                                                                            // Sinon

        $(document.querySelectorAll("input[name=\"group\"]")).prop("disabled", true);   // On fait l'inverse.
        $("#layout-group").fadeOut(150);
        $("#collapse_group").fadeOut(150);
        if (!$("#nogroup").checked) $("#nogroup").prop("checked", true);                // Sans oublier de remettre la sélection par défaut.
    }
}
/**
 * Permet d'imprimer la page d'aide.
 */
function printHelp () {
    $("#print_help").click(function () {
        $("#help_main_screen > section, #help_graph > section, #help_settings > section").show();
        $("#help_main_screen, #help_graph, #help_settings").find("h2").addClass("open");
        
        $("#help_dialog").print({
            globalStyles: false,
            mediaPrint: false,
            stylesheet: racineUrl + "resource/css/help_print.css",
            //stylesheet: null,
            noPrintSelector: ".no-print",
            iframe: true,
            manuallyCopyFormValues: false
        });
    });
}
/**
 * @description Donne une classe css en fonction du nombre donnée.
 * @param {number} num
 */
function getClassColor(num){
    if (vastGradient)   return hugeGradient(num);
    else                return tightGradient(num);
}
/**
 * @description Change the impact color of the node from 3 colors to 5.
 */
function changeVastGradientState () {
    vastGradient = !vastGradient;
    graph.majGraphColor();
}
/**
 * @description Return the node class for a vast gradient color between green and red.
 * @param num
 * @returns {*}
 */
function hugeGradient (num) {
    if (num === 0)        return css_classes.living ;
    else if (num < 25)    return css_classes.scratch ;
    else if (num < 50)    return css_classes.minor ;
    else if (num < 75)    return css_classes.illness ;
    else if (num < 100)   return css_classes.important ;
    else if (num === 100) return css_classes.dead ;
    else                  return css_classes.black;
}
/**
 * @description Give the node class for a tight gradient color between green and red.
 * @param {number} num
 * @returns {string}
 */
function tightGradient (num) {
    if (num === 0)        return css_classes.living ;
    else if (num < 50)    return css_classes.minor ;
    else if (num < 100)   return css_classes.important ;
    else if (num === 100) return css_classes.dead ;
    else                  return css_classes.black;
}

/**
 * @description Remove duplicate value in array.
 * @param {Array} arr
 */
function removeDuplicateValueInArray (arr) {
    arr = arr.filter(function (value, index, array) {
        return array.lastIndexOf(value) === index;
    });
}
/**
 * @description Show an error message if the user select a group (only if the group is collapse).
 */
function cannotselectgroup () {
    $("#cannotselect").html("Can not select a group").removeClass("hidden");
}
/**
 * @description Show an error message if the user select 2 nodes that belongs to the same path.
 */
function cannotselecttwoonsamepath () {
    $("#cannotselect").html("Can not select 2 nodes that belongs to the same path").removeClass("hidden");
}
/**
 * @description During page loading, if Storage and sessionStorage items set, check last settings validate by the user.
 * @param {string} name
 * @param {string|boolean|number} value
 */
function input_pre_check (name, value) {
    $.each($("input[name=\"" + name + "\"]"), function () { $(this).prop("checked", false); });
    $("input[name=\"" + name + "\"][value=\"" + value + "\"]").prop("checked", true);
}
/**
 * @description Make a new request with updated depths.
 * @param {string|undefined} causeDepth
 * @param {string|undefined} impactDepth
 */
function reloadWithDepth (causeDepth, impactDepth) {
    if (causeDepth !== undefined || impactDepth !== undefined) {
        if (causeDepth !== undefined) {
            impactDepth = myImpactDepth.toString();
        } else if (impactDepth !== undefined) {
            causeDepth = myCauseDepth.toString();
        }
    }

    var filter = getLabelFiltre();

    window.location.href = racineUrl + "lavoisier/impact?" +
        (myClass !== "*" ? "Class="+myClass : "") +
        (myKey !== "*" ? (myClass != "*" ? "&" : "")+"Key="+myKey : "") +
        ((myClass !== "*" || myKey !== "*") ? "&" : "")+"Value="+myValue +
        (filter.length !== 0 ? "&Filter="+filter.join("|") : "") +
        (impactDepth !== undefined ? "&ImpactDepth="+impactDepth : "") +
        (causeDepth !== undefined ? "&CauseDepth="+causeDepth : "") +
        (myImpactLevel ? "&ImpactLevel="+myImpactLevel : "") +
        (myLimit ? "&Limit="+myLimit : "");
}
/**
 * @description Verified if all filter is checked.
 */
function allFilterActivated () {
    var response = true;
    $.each($("input.nodeclass"), function (index, input) {
        if ($(input).is(":checked")) {
            response = false;
            return;
        }
    });
    return response;
}

/* NO GRAPH     NO GRAPH     NO GRAPH     NO GRAPH     NO GRAPH     NO GRAPH     NO GRAPH     NO GRAPH     NO GRAPH     NO GRAPH */
/**
 * @description Go to the view Cards of Lavoisier with the selected Class.
 */
function listNG () {
    window.location.href = racineUrl + "lavoisier/cards?Class=" + $("#Class-noGraph").val();
}
/**
 * @description Show the advanced settings of the form.
 */
function advancedFormNG () {
    $(".no-graph-advanced").toggleClass("hide");
    $("#advancedForm-no-graph").html(($(".no-graph-advanced").hasClass("hide") ? "+" : "-"));
}
/**
 * @description Reload this page with a new request.
 * @var {event} evt Submission event from the form.
 */
function getDataNG (evt) {
    evt.preventDefault();

    var CLASS = $("#Class-noGraph").val();
    var KEY = $("#Key-noGraph").val();
    var VALUE = $("#Value-noGraph").val();
    var FILTER = $("#Filter-noGraph").val();
    var IMPACTDEPTH = $("#ImpactDepth-noGraph").val() || "0";
    var CAUSEDEPTH = $("#CauseDepth-noGraph").val() || "0";
    var IMPACTLEVEL = $("#ImpactLevel-noGraph").val();
    var CYPHER = $("#Cypher-noGraph").val();
    var LIMIT = $("#Limit-noGraph").val();

    if (VALUE !== "") {
        window.location.href = racineUrl + "lavoisier/impact?" +
                (CLASS != "*" ? "Class="+CLASS : "") +
                (KEY != "" ? (CLASS != "*" ? "&" : "")+"Key="+KEY : "") +
                ((CLASS != "*" || KEY) ? "&" : "")+"Value=.*"+VALUE+".*" +
                (FILTER ? "&Filter="+FILTER : "") +
                (IMPACTDEPTH ? "&ImpactDepth="+IMPACTDEPTH : "") +
                (CAUSEDEPTH ? "&CauseDepth="+CAUSEDEPTH : "") +
                (IMPACTLEVEL != "" ? "&ImpactLevel="+IMPACTLEVEL : "") +
                (LIMIT != "" ? "&Limit="+LIMIT : "");
    } else if (CYPHER) {
        window.location.href = racineUrl + "lavoisier/impact?" +
                "Cypher="+encodeURIComponent(CYPHER) +
                (FILTER != "" ? "&Filter="+FILTER : "") +
                (IMPACTLEVEL != "" ? "&ImpactLevel="+IMPACTLEVEL : "") +
                (LIMIT != "" ? "&Limit="+LIMIT : "");
    } else {
        /* Message d'erreur. */
        alert("Field 'Value' must not be empty !");
    }

    return false;
}